Index: linux-4.19.118/include/linux/netdevice.h
===================================================================
--- linux-4.19.118.orig/include/linux/netdevice.h
+++ linux-4.19.118/include/linux/netdevice.h
@@ -4648,15 +4648,29 @@ do {								\
 do {								\
 	dynamic_netdev_dbg(__dev, format, ##args);		\
 } while (0)
+#define netdev_dbg_ratelimited(__dev, format, args...)			\
+do {									\
+	DEFINE_DYNAMIC_DEBUG_METADATA(descriptor, format);		\
+	if (unlikely(descriptor.flags & _DPRINTK_FLAGS_PRINT) &&	\
+	    net_ratelimit())						\
+		dynamic_netdev_dbg(__dev, format, ##args);		\
+} while (0)
 #elif defined(DEBUG)
-#define netdev_dbg(__dev, format, args...)			\
-	netdev_printk(KERN_DEBUG, __dev, format, ##args)
+#define netdev_dbg(__dev, format, args...)				\
+	netdev_printk(KERN_DEBUG, __dev, format, ##args)		\
+#define netdev_dbg_ratelimited(__dev, format, args...)			\
+	netdev_printk(KERN_DEBUG, __dev, format, ##args)		\
 #else
 #define netdev_dbg(__dev, format, args...)			\
 ({								\
 	if (0)							\
 		netdev_printk(KERN_DEBUG, __dev, format, ##args); \
 })
+#define netdev_dbg_ratelimited(__dev, format, args...)		\
+({							\
+	if (0)						\
+		netdev_printk(KERN_DEBUG, __dev, format, ##args); \
+})
 #endif
 
 #if defined(VERBOSE_DEBUG)
